#include <Application/Application.h>

void Application::apply_deffer_state_change() noexcept {
    if (m_ptr_state_next)
        m_ptr_state_current = std::move(m_ptr_state_next);
}

int Application::run() {
    while (m_ptr_state_current->do_step())
        apply_deffer_state_change();
    return 0;
}